#include (rules.inc)
[top]
components : battle1

[battle1]
type : cell
dim : (10,10)
delay : transport
defaultDelayTime : 100
border : wrapped

neighbors : 		  battle(-1,0)
neighbors : battle(0,-1)  battle(0,0)  battle(0,1) 
neighbors : 	          battle(1,0)

initialvalue : 0 
initialcellsvalue : battle1.val
localtransition : combat-rule

%fighting-ability == fa  , fighter-status== fs

neighborports : fa  fs direction  enemy_flag 


[combat-rule]


%================================================ initialization ==========================================================

rule : { ~fs := trunc((0,0)~fs)+1 ; ~fa := abs(fractional((0,0)~fa)) ; ~direction := 0; ~enemy_flag := 1.01 ; }  0                       {  fractional((0,0)~fs) != 0 and (0,0)~fs < 0 } 
rule : { ~fs := trunc((0,0)~fs) ; ~fa := abs(fractional((0,0)~fa)) ; ~direction := 0 ; ~enemy_flag := 8.08 ; }  0                       {  fractional((0,0)~fs) != 0 and (0,0)~fs >= 0 }
rule : { ~fs := 5 ; ~fa := 0; ~direction := 0;  } 0 { (0,0)~fs = 5 and (0,0)~fa = 5 }
rule : { ~fs := -5 ; ~fa := 0; ~direction := 0; } 0 { (0,0)~fs = -5 and (0,0)~fa = -5 }
%==========================================================================================================================

%================================== Army A fighter is surrounded by an enemy fighter ======================================

rule : { ~fs:= 1 ; ~fa:= uniform(0,0.55) ; ~direction := 0 ;  } 100 
	            {  (0,0)~fs = 1 and ( statecount(-1, ~fs) + statecount(-2, ~fs) ) > 0  and (#macro(fight_rule_1)) = 0  }
rule : { ~fs:= 0 ; ~fa:= 0 ; ~direction := 0 ; ~enemy_flag := -1 ; }  100 
                    {  (0,0)~fs = 1 and ( statecount(-1, ~fs) + statecount(-2, ~fs) ) > 0 and  (#macro(fight_rule_1)) < 0  }
rule : { ~fs:= 2 ; ~fa:= uniform(0.45,0.99) ; ~direction := 0; } 100 
                    {  (0,0)~fs = 2 and  ( statecount(-1, ~fs) + statecount(-2, ~fs) ) > 0 and (#macro(fight_rule_1)) = 0  }
rule : { ~fs:= 1 ; ~fa:= uniform(0,0.55) ; ~direction := 0 ;  } 100 
                    {  (0,0)~fs = 2 and ( statecount(-1, ~fs) + statecount(-2, ~fs) ) > 0 and  (#macro(fight_rule_1)) = -1 }
rule : { ~fs:= 0 ; ~fa:= 0 ; ~direction := 0 ; ~enemy_flag := -1; }  100 
                    {  (0,0)~fs = 2 and ( statecount(-1, ~fs) + statecount(-2, ~fs) ) > 0 and  (#macro(fight_rule_1)) < -1 }
%==========================================================================================================================

%==================================== Army B fighter is surrounded by an enemy fighter ====================================

rule : { ~fs:= -1 ; ~fa:= uniform(0,0.55) ; ~direction := 0 ; } 100
                    {  (0,0)~fs = -1 and ( statecount(1, ~fs) + statecount(2, ~fs) ) > 0  and (#macro(fight_rule_2)) = 0  }
rule : { ~fs:= 0 ; ~fa:= 0 ; ~direction := 0 ; ~enemy_flag := -1; }  100
                    {  (0,0)~fs = -1 and ( statecount(1, ~fs) + statecount(2, ~fs) ) > 0 and  (#macro(fight_rule_2)) > 0  }
rule : { ~fs:= -2 ; ~fa:= uniform(0.45,0.99) ; ~direction := 0 ; } 100
                    {  (0,0)~fs = -2 and  ( statecount(1, ~fs) + statecount(2, ~fs) ) > 0 and (#macro(fight_rule_2)) = 0  }
rule : { ~fs:= -1 ; ~fa:= uniform(0,0.55) ; ~direction := 0 ; }  100
                    {  (0,0)~fs = -2 and ( statecount(1, ~fs) + statecount(2, ~fs) ) > 0 and  (#macro(fight_rule_2)) = 1 }
rule : { ~fs:= 0 ; ~fa:= 0 ; ~direction := 0 ; ~enemy_flag := -1 ; } 100
                    {  (0,0)~fs = -2 and ( statecount(1, ~fs) + statecount(2, ~fs) ) > 0 and  (#macro(fight_rule_2)) > 1 }
%==========================================================================================================================

%============================================== flags under attack ========================================================

rule : { ~fs := if ( (#macro(fight_rule_3)) != 0, 0 , 5 ) ; ~fa := 0 ; } 100
                                        { (0,0)~fs = 5 and (statecount(-1,~fs) + statecount(-2,~fs)) > 0    }
rule : { ~fs := if ( (#macro(fight_rule_4)) != 0, 0 , -5 ) ; ~fa := 0 ; } 100 
					{ (0,0)~fs = -5 and (statecount(1,~fs) + statecount(2,~fs)) > 0    }
%==========================================================================================================================

%============================================= flags are NOT  attacked ====================================================

rule : { ~fs := 5 ; ~fa := 0 ; } 100 {  (0,0)~fs = 5 and (statecount(-1, ~fs) + statecount(-2, ~fs)) = 0 }
rule : { ~fs := -5 ; ~fa := 0 ;  } 100 { (0,0)~fs = -5 and (statecount(1, ~fs) + statecount(2, ~fs)) = 0 }
%==========================================================================================================================

%=================================== Injured-fighter is not surrounded by an enemy fighter =================================

rule : { ~fs := 2 ; ~fa:= uniform(0.45,0.99) ; }  100 
				{  (0,0)~fs = 1  and (statecount(-1, ~fs) + statecount(-2, ~fs)) = 0 }
rule : { ~fs := -2 ; ~fa:= uniform(0.45,0.99); } 100 
				{  (0,0)~fs = -1 and (statecount(1, ~fs) + statecount(2, ~fs)) = 0 }
%============================================================================================================================

%======================================================= Moving directions ==================================================

rule : { ~fs := 2 ; ~fa := (0,0)~fa ; ~direction := (#macro(director_row)); }  0                                               {  (0,0)~fs = 2 and (statecount(-1, ~fs) + statecount(-2, ~fs)) = 0  and (0,0)~direction = 0 and                                (0,0)~enemy_flag >= 0 and   cellPos(0) = trunc((0,0)~enemy_flag ) and                                                cellPos(1) != round(fractional((0,0)~enemy_flag) * 100)   }
                                                           
rule : { ~fs := 2; ~fa := (0,0)~fa ; ~direction := (#macro(director_column)); } 0                                                 { (0,0)~fs = 2 and (statecount(-1,~fs) + statecount(-2,~fs)) = 0 and (0,0)~direction =0 and                                   (0,0)~enemy_flag >= 0 and cellPos(0) != trunc((0,0)~enemy_flag) and                                                  cellPos(1) = round(fractional((0,0)~enemy_flag) * 100) } 

rule : { ~fs := 2; ~fa := (0,0)~fa ; ~direction := (#macro(director_row_column)) ;} 0                                             { (0,0)~fs = 2 and (statecount(-1, ~fs) + statecount(-2, ~fs)) = 0 and (0,0)~direction = 0 and                                 (0,0)~enemy_flag >= 0 and cellPos(0) != trunc((0,0)~enemy_flag) and                                                  cellPos(1) != round(fractional((0,0)~enemy_flag) * 100) }


rule : { ~fs := -2 ; ~fa := (0,0)~fa ; ~direction := (#macro(director_row)); }  0                                                   {  (0,0)~fs = -2 and (statecount(1, ~fs) + statecount(2, ~fs)) = 0  and (0,0)~direction = 0                                       and (0,0)~enemy_flag >= 0 and cellPos(0) = trunc((0,0)~enemy_flag) and                                              cellPos(1) != round(fractional((0,0)~enemy_flag) * 100)  }

rule : { ~fs := -2 ; ~fa := (0,0)~fa ; ~direction := (#macro(director_column)); } 0
          {  (0,0)~fs = -2 and (statecount(1, ~fs) + statecount(2, ~fs)) = 0 and (0,0)~direction = 0 and                                     (0,0)~enemy_flag >= 0 and cellPos(0) != trunc((0,0)~enemy_flag) and                                                cellPos(1) = round(fractional((0,0)~enemy_flag) * 100) }

rule : { ~fs := -2 ; ~fa := (0,0)~fa ; ~direction := (#macro(director_row_column)) ;}  0                                                   { (0,0)~fs = -2 and (statecount(1, ~fs) + statecount(2, ~fs) ) = 0  and (0,0)~direction = 0 and                                 (0,0)~enemy_flag >= 0 and cellPos(0) !=  trunc((0,0)~enemy_flag) and                                               cellPos(1) != round(fractional((0,0)~enemy_flag) * 100) }

%===========================================================================================================================

%=============================================== Free cell move-in =========================================================

#macro(move_from_west_factor)
#macro(move_from_west)

#macro(move_from_east_factor)
#macro(move_from_east) 

#macro(move_from_north_factor)
#macro(move_from_north) 

#macro(move_from_south_factor)
#macro(move_from_south)

%===========================================================================================================================

%======================================= if non of the above rules evaluates ==============================================
rule : {0} 100 { t }



